## game-music-emu 0.6.4

=== CMakeLists.txt ===
# CMake project definition file.
cmake_minimum_required(VERSION 3.3...3.10)
project(libgme)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(CMakePushCheckState)
include(CheckCXXSourceCompiles)
include(TestBigEndian)
include(GNUInstallDirs)
include(CTest)

file(READ "gme/gme.h" GME_GME_H)
string(REGEX MATCH "/\\* Game_Music_Emu ([0-9]+)\\.([0-9]+).([0-9]+) \\*/" RE_GME_VERSION "${GME_GME_H}")
if(NOT RE_GME_VERSION)
    message(FATAL_ERROR "Unable to extract gme version from gme/gme.h")
endif()
set(GME_VERSION_MAJOR "${CMAKE_MATCH_1}")
set(GME_VERSION_MINOR "${CMAKE_MATCH_2}")
set(GME_VERSION_PATCH "${CMAKE_MATCH_3}")
set(GME_VERSION "${GME_VERSION_MAJOR}.${GME_VERSION_MINOR}.${GME_VERSION_PATCH}")

if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
    set(GME_IS_ROOT TRUE)
else()
    set(GME_IS_ROOT FALSE)
endif()

# Default emulators to build (all of them! ;)
option(USE_GME_AY "Enable support for Spectrum ZX music emulation" ON)
option(USE_GME_GBS "Enable support for Game Boy music emulation" ON)
option(USE_GME_GYM "Enable Sega MegaDrive/Genesis music emulation" ON)
option(USE_GME_HES "Enable PC Engine/TurboGrafx-16 music emulation" ON)
option(USE_GME_KSS "Enable MSX or other Z80 systems music emulation" ON)
option(USE_GME_NSF "Enable NES NSF music emulation" ON)
option(USE_GME_NSFE "Enable NES NSFE and NSF music emulation" ON)
option(USE_GME_SAP "Enable Atari SAP music emulation" ON)
option(USE_GME_SPC "Enable SNES SPC music emulation" ON)
option(USE_GME_VGM "Enable Sega VGM/VGZ music emulation" ON)

option(GME_SPC_ISOLATED_ECHO_BUFFER "Enable isolated echo buffer on SPC emulator to allow correct playing of \"dodgy\" SPC files made for various ROM hacks ran on ZSNES" OFF)
option(GME_ZLIB "Enable GME to support compressed sound formats" ON)

set(GME_YM2612_EMU "Nuked" CACHE STRING "Which YM2612 emulator to use: \"Nuked\" (LGPLv2.1+), \"MAME\" (GPLv2+), or \"GENS\" (LGPLv2.1+)")
set(GME_YM2612_EMU_CHOICES "Nuked;MAME;GENS")
set_property(CACHE GME_YM2612_EMU PROPERTY STRINGS "${GME_YM2612_EMU_CHOICES}")

if(USE_GME_NSFE AND NOT USE_GME_NSF)
    message(STATUS "NSFE support requires NSF, enabling NSF support.")
    set(USE_GME_NSF 1 CACHE BOOL "Enable NES NSF music emulation" FORCE)
endif()

if(DEFINED BUILD_SHARED_LIBS)
    set(GME_BUILD_SHARED_DEFAULT ${BUILD_SHARED_LIBS})
else()
    set(GME_BUILD_SHARED_DEFAULT ON)
endif()

option(GME_BUILD_SHARED "Build shared library" ${GME_BUILD_SHARED_DEFAULT})
option(GME_BUILD_STATIC "Build static library" ON)
option(GME_BUILD_FRAMEWORK "Build framework instead of dylib on macOS" ${BUILD_FRAMEWORK})

option(GME_ENABLE_UBSAN "Enable Undefined Behavior Sanitizer error-checking" ${ENABLE_UBSAN})
option(GME_BUILD_TESTING "Build demo tests" ${BUILD_TESTING})
option(GME_BUILD_EXAMPLES "Add example project build rules" ${GME_IS_ROOT})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

test_big_endian(WORDS_BIGENDIAN)

if(MSVC)
    string(REGEX REPLACE "/W[3|4]" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
    string(REGEX REPLACE "/W[3|4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    add_compile_options(/W2)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    add_compile_options(-Wall -W -Wextra)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)

# Enable debug asserts when build type is debug
if(CMAKE_BUILD_TYPE_LOWER STREQUAL "debug")
    if(CMAKE_COMPILER_IS_GNUCXX)
        add_definitions(-D_GLIBCXX_DEBUG=1 -D_GLIBCXX_ASSERTIONS=1)
    endif()
endif()

# c++ tweaks
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti -fno-exceptions")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-")
endif()

# Check for GCC/Clang "visibility" support.
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang" AND GME_ENABLE_UBSAN)
    # GCC needs -static-libubsan
    if(NOT GME_BUILD_SHARED AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -static-libubsan")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
    endif()
endif()

# Shared library defined here
add_subdirectory(gme)

# Add example project build rules
if (GME_BUILD_EXAMPLES)
    # EXCLUDE_FROM_ALL adds build rules but keeps it out of default build
    add_subdirectory(player EXCLUDE_FROM_ALL)
    add_subdirectory(demo EXCLUDE_FROM_ALL)
endif()

=== demo/CMakeLists.txt ===
# Rules for building the demo.  Doesn't use an installed gme if you've already
# installed the project so if you're copying these rules you probably don't
# even need these next two lines if you're building against system-installed
# gme.
include_directories(${CMAKE_SOURCE_DIR}/gme ${CMAKE_SOURCE_DIR})
link_directories(${CMAKE_BINARY_DIR}/gme)

set (CMAKE_C_STANDARD 99)

add_executable(demo Wave_Writer.cpp basics.c)

# Add command to copy build file over.
add_custom_command(TARGET demo
    POST_BUILD
    COMMAND cmake -E copy "${CMAKE_SOURCE_DIR}/test.nsf" ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND cmake -E copy "${CMAKE_SOURCE_DIR}/test/checksums" ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Add convenience copy of test.nsf file for demo application"
    VERBATIM) # VERBATIM is essentially required, "please use correct command line kthx"

target_link_libraries(demo gme::gme)


add_executable(demo_mem Wave_Writer.cpp basics_mem.c)

add_custom_command(TARGET demo_mem
    POST_BUILD
    COMMAND cmake -E copy "${CMAKE_SOURCE_DIR}/test.vgz" ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Add convenience copy of test.vgz file for demo application"
    VERBATIM) # VERBATIM is essentially required, "please use correct command line kthx"

target_link_libraries(demo_mem gme::gme)


add_executable(demo_multi Wave_Writer.cpp basics_multi.c)
target_link_libraries(demo_multi gme::gme)

#
# Testing
#

if(GME_BUILD_TESTING)
    add_test(NAME sanity_test_NSF
        COMMAND demo)
    add_test(NAME check_proper_NSF_output
        COMMAND sha256sum -c "${CMAKE_CURRENT_BINARY_DIR}/checksums")
endif()

=== gme/CMakeLists.txt ===

if(NOT GME_BUILD_SHARED AND NOT GME_BUILD_STATIC)
    message(FATAL_ERROR "Both shared and static builds disabled. Please enable build of shared and/or static build of the GME.")
endif()

if(GME_ZLIB)
    find_package(ZLIB QUIET)
endif()

# List of source files required by libgme and any emulators
# This is not 100% accurate (Fir_Resampler for instance) but
# you'll be OK.
set(libgme_SRCS Blip_Buffer.cpp
                Blip_Buffer.h
                Classic_Emu.cpp
                Classic_Emu.h
                Data_Reader.cpp
                Data_Reader.h
                Dual_Resampler.cpp
                Dual_Resampler.h
                Effects_Buffer.cpp
                Effects_Buffer.h
                Fir_Resampler.cpp
                Fir_Resampler.h
                gme.cpp
                gme.h
                gme_types.h
                Gme_File.cpp
                Gme_File.h
                M3u_Playlist.cpp
                M3u_Playlist.h
                Multi_Buffer.cpp
                Multi_Buffer.h
                Music_Emu.cpp
                Music_Emu.h
                blargg_common.h
                blargg_config.h
                blargg_endian.h
                blargg_source.h
                )

# Ay_Apu is very popular around here
if(USE_GME_AY OR USE_GME_KSS)
    list(APPEND libgme_SRCS
                Ay_Apu.cpp
                Ay_Apu.h
        )
endif()

# so is Ym2612_Emu
if(USE_GME_VGM OR USE_GME_GYM)
    if(GME_YM2612_EMU STREQUAL "Nuked")
        add_definitions(-DVGM_YM2612_NUKED)
        list(APPEND libgme_SRCS
                    Ym2612_Nuked.cpp
                    Ym2612_Nuked.h
            )
        message(STATUS "VGM/GYM: Nuked OPN2 emulator will be used")
    elseif(GME_YM2612_EMU STREQUAL "MAME")
        add_definitions(-DVGM_YM2612_MAME)
        list(APPEND libgme_SRCS
                    Ym2612_MAME.cpp
                    Ym2612_MAME.h
            )
        message(STATUS "VGM/GYM: MAME YM2612 emulator will be used")
    else()
        add_definitions(-DVGM_YM2612_GENS)
        list(APPEND libgme_SRCS
                    Ym2612_GENS.cpp
                    Ym2612_GENS.h
            )
        message(STATUS "VGM/GYM: GENS 2.10 emulator will be used")
    endif()
endif()

# But none are as popular as Sms_Apu
if(USE_GME_VGM OR USE_GME_GYM OR USE_GME_KSS)
    list(APPEND libgme_SRCS
                Sms_Apu.cpp
                Sms_Apu.h
        )
endif()

if(USE_GME_AY)
    list(APPEND libgme_SRCS
              # Ay_Apu.cpp included earlier
                Ay_Cpu.cpp
                Ay_Cpu.h
                Ay_Emu.cpp
                Ay_Emu.h
        )
endif()

if(USE_GME_GBS)
    list(APPEND libgme_SRCS
                Gb_Apu.cpp
                Gb_Apu.h
                Gb_Cpu.cpp
                Gb_Cpu.h
                Gb_Oscs.cpp
                Gb_Oscs.h
                Gbs_Emu.cpp
                Gbs_Emu.h
                gb_cpu_io.h
        )
endif()

if(USE_GME_GYM)
    list(APPEND libgme_SRCS
              # Sms_Apu.cpp included earlier
              # Ym2612_Emu.cpp included earlier
                Gym_Emu.cpp
                Gym_Emu.h
        )
endif()

if(USE_GME_HES)
    list(APPEND libgme_SRCS
                Hes_Apu.cpp
                Hes_Apu.h
                Hes_Cpu.cpp
                Hes_Cpu.h
                Hes_Emu.cpp
                Hes_Emu.h
                hes_cpu_io.h
        )
endif()

if(USE_GME_KSS)
    list(APPEND libgme_SRCS
              # Ay_Apu.cpp included earlier
              # Sms_Apu.cpp included earlier
                Kss_Cpu.cpp
                Kss_Cpu.h
                Kss_Emu.cpp
                Kss_Emu.h
                Kss_Scc_Apu.cpp
                Kss_Scc_Apu.h
        )
endif()

if(USE_GME_NSF OR USE_GME_NSFE)
    list(APPEND libgme_SRCS
                Nes_Apu.cpp
                Nes_Apu.h
                Nes_Cpu.cpp
                Nes_Cpu.h
                Nes_Fme7_Apu.cpp
                Nes_Fme7_Apu.h
                Nes_Namco_Apu.cpp
                Nes_Namco_Apu.h
                Nes_Oscs.cpp
                Nes_Oscs.h
                Nes_Vrc6_Apu.cpp
                Nes_Vrc6_Apu.h
                Nes_Fds_Apu.cpp
                Nes_Fds_Apu.h
                Nes_Vrc7_Apu.cpp
                Nes_Vrc7_Apu.h
                ext/emu2413.c
                ext/emu2413.h
                ext/panning.c
                ext/panning.h
                ext/emutypes.h
                ext/2413tone.h
                ext/vrc7tone.h
                Nsf_Emu.cpp
                Nsf_Emu.h
        )
endif()

if(USE_GME_NSFE)
    list(APPEND libgme_SRCS
                Nsfe_Emu.cpp
                Nsfe_Emu.h
        )
endif()

if(USE_GME_SAP)
    list(APPEND libgme_SRCS
                Sap_Apu.cpp
                Sap_Cpu.cpp
                Sap_Emu.cpp
                sap_cpu_io.h
        )
endif()

if(USE_GME_SPC)
    list(APPEND libgme_SRCS
                Snes_Spc.cpp
                Snes_Spc.h
                Spc_Cpu.cpp
                Spc_Cpu.h
                Spc_Dsp.cpp
                Spc_Dsp.h
                Spc_Emu.cpp
                Spc_Emu.h
                Spc_Filter.cpp
                Spc_Filter.h
        )
    if(GME_SPC_ISOLATED_ECHO_BUFFER)
        add_definitions(-DSPC_ISOLATED_ECHO_BUFFER)
    endif()
endif()

if(USE_GME_VGM)
    list(APPEND libgme_SRCS
              # Sms_Apu.cpp included earlier
              # Ym2612_Emu.cpp included earlier
                Vgm_Emu.cpp
                Vgm_Emu.h
                Vgm_Emu_Impl.cpp
                Vgm_Emu_Impl.h
                Ym2413_Emu.cpp
                Ym2413_Emu.h
        )
endif()

# These headers are part of the generic gme interface.
set (EXPORTED_HEADERS gme.h)

# while building a macOS framework, exported headers must be in the source
# list, or the header files aren't copied to the bundle.
if(GME_BUILD_FRAMEWORK)
    set(libgme_SRCS ${libgme_SRCS} ${EXPORTED_HEADERS})
endif()

# Extract symbols from gme.exports
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/gme.exports" gme_exports_strings)
set(gme_exports)
foreach(gme_export_string ${gme_exports_strings})
    string(STRIP "${gme_export_string}" gme_export_string)
    string(SUBSTRING "${gme_export_string}" 0 1 gme_export_first_char)
    if(gme_export_string AND NOT gme_export_first_char STREQUAL "#")
        list(APPEND gme_exports ${gme_export_string})
    endif()
endforeach()


add_library(gme_deps INTERFACE)

## FIXME: Properly find the C++ library !!!
set(PC_LIBS -lstdc++)

if(GME_ZLIB)
    if(ZLIB_FOUND)
        message(STATUS "ZLib library located, compressed file formats will be supported")
        target_compile_definitions(gme_deps INTERFACE HAVE_ZLIB_H)
        target_link_libraries(gme_deps INTERFACE ZLIB::ZLIB)
        # Is not to be installed though
        list(APPEND PC_LIBS -lz) # for libgme.pc
    else()
        message(STATUS "** ZLib library not found, disabling support for compressed formats such as VGZ")
    endif()
else()
    message(STATUS "Zlib-Compressed formats excluded")
endif()

if(NOT MSVC)
    # Link with -no-undefined, if available
    if(NOT APPLE AND NOT CMAKE_SYSTEM_NAME MATCHES ".*OpenBSD.*")
        cmake_push_check_state()
        set(CMAKE_REQUIRED_FLAGS "-Wl,-no-undefined")
            check_cxx_source_compiles("int main(void) { return 0;}" LINKER_SUPPORTS_NO_UNDEFINED)
        cmake_pop_check_state()
    endif()

    # Link to libm, if necessary
    check_cxx_source_compiles("
        #include <math.h>
        int main(int argc, char** argv) {
            return (int) pow(argc, 2.5);
        }" LIBM_NOT_NEEDED)
    if(NOT LIBM_NOT_NEEDED)
        cmake_push_check_state()
        set(CMAKE_REQUIRED_LIBRARIES "-lm")
        check_cxx_source_compiles("
            #include <math.h>
            int main(int argc, char** argv) {
                return (int) pow(argc, 2.5);
            }" HAVE_LIBM)
        cmake_pop_check_state()
        if(HAVE_LIBM)
            list(APPEND PC_LIBS -lm) # for libgme.pc
        endif()
    endif()
endif()

# Add a version script to hide the c++ STL
if(APPLE)
    set(gme_syms "")
    foreach(gme_export ${gme_exports})
        set(gme_syms "${gme_syms}_${gme_export}\n")
    endforeach()

    # Use an intermediate 'gme_generated.sym' file to avoid a relink every time CMake runs
    set(temporary_sym_file "${CMAKE_CURRENT_BINARY_DIR}/gme_generated.sym")
    set(generated_sym_file "${CMAKE_CURRENT_BINARY_DIR}/gme.sym")
    file(WRITE "${temporary_sym_file}" "${gme_syms}")
    execute_process(COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${temporary_sym_file}" "${generated_sym_file}")
elseif(UNIX)
    set(gme_syms "{\n  global:\n")
    foreach(gme_export ${gme_exports})
        set(gme_syms "${gme_syms}    ${gme_export};\n")
    endforeach()
    set(gme_syms "${gme_syms}  local: *;\n};\n")

    # Use an intermediate 'gme_generated.sym' file to avoid a relink every time CMake runs
    set(temporary_sym_file "${CMAKE_CURRENT_BINARY_DIR}/gme_generated.sym")
    set(generated_sym_file "${CMAKE_CURRENT_BINARY_DIR}/gme.sym")
    file(WRITE "${temporary_sym_file}" "${gme_syms}")
    execute_process(COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${temporary_sym_file}" "${generated_sym_file}")

    cmake_push_check_state()
    set(CMAKE_REQUIRED_FLAGS "-Wl,-version-script='${generated_sym_file}'")
    check_cxx_source_compiles("int main() { return 0;}" LINKER_SUPPORTS_VERSION_SCRIPT)
    cmake_pop_check_state()
endif()


set(INSTALL_TARGETS)

# Shared properties for shared and static builds of libGME
macro(set_gme_props gme_target)
    list(APPEND INSTALL_TARGETS ${gme_target})

    set_property(TARGET ${gme_target} PROPERTY C_VISIBILITY_PRESET "hidden")
    set_property(TARGET ${gme_target} PROPERTY VISIBILITY_INLINES_HIDDEN TRUE)
    set_property(TARGET ${gme_target} PROPERTY CXX_VISIBILITY_PRESET "hidden")

    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        target_compile_definitions(${gme_target} PRIVATE LIBGME_VISIBILITY)
    endif()

    target_compile_definitions(${gme_target} PRIVATE GEN_TYPES_H)
    if(WORDS_BIGENDIAN)
        target_compile_definitions(${gme_target} PRIVATE BLARGG_BIG_ENDIAN=1)
    else()
        target_compile_definitions(${gme_target} PRIVATE BLARGG_LITTLE_ENDIAN=1)
    endif()

    # Try to protect against undefined behavior from signed integer overflow
    # This has caused miscompilation of code already and there are other
    # potential uses; see https://bitbucket.org/mpyne/game-music-emu/issues/18/
    #                    (https://github.com/libgme/game-music-emu/issues/20 )
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        target_compile_options(${gme_target} PRIVATE -fwrapv)
    endif()

    target_include_directories(${gme_target}
        PRIVATE "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"  # For gen_types.h
        INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>"
        INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    )

    if(NOT MSVC)
        # Link with -no-undefined, if available
        if(APPLE)
            set_property(TARGET ${gme_target} APPEND_STRING PROPERTY LINK_FLAGS " -Wl,-undefined,error")
        elseif(NOT CMAKE_SYSTEM_NAME MATCHES ".*OpenBSD.*" AND LINKER_SUPPORTS_NO_UNDEFINED)
            set_property(TARGET ${gme_target} APPEND_STRING PROPERTY LINK_FLAGS " -Wl,-no-undefined")
        endif()
    endif()

endmacro()

# Building the Shared version of GME
if(GME_BUILD_SHARED)
    add_library(gme_shared SHARED ${libgme_SRCS})
    set_target_properties(gme_shared PROPERTIES OUTPUT_NAME gme)

    if(WIN32)
        set_property(TARGET gme_shared PROPERTY DEFINE_SYMBOL BLARGG_BUILD_DLL)
    endif()

    set_gme_props(gme_shared)

    # Add a version script to hide the c++ STL
    if(APPLE)
        set_property(TARGET gme_shared APPEND_STRING PROPERTY LINK_FLAGS " -Wl,-exported_symbols_list,'${generated_sym_file}'")
        set_property(TARGET gme_shared APPEND PROPERTY LINK_DEPENDS "${generated_sym_file}")

=== player/CMakeLists.txt ===
option(GME_UNRAR "Enable RAR file format (optional, requires UnRAR library)" ON)

find_package(SDL2)

if (GME_UNRAR)
    find_package(UNRAR QUIET)
endif()


set(player_SRCS Audio_Scope.cpp
                Audio_Scope.h
                Music_Player.cpp
                Music_Player.h
                Archive_Reader.cpp
                Archive_Reader.h
                player.cpp)

if(SDL2_FOUND)
    message(STATUS "SDL2 library located, player demo is available to be built in the /player directory")

    add_executable(gme_player ${player_SRCS})
    target_include_directories(gme_player PRIVATE
        ${SDL2_INCLUDE_DIRS}
        ${PROJECT_SOURCE_DIR}/gme
    )
    set_property(TARGET gme_player PROPERTY CXX_STANDARD_REQUIRED ON)
    set_property(TARGET gme_player PROPERTY CXX_STANDARD 11)
    target_link_libraries(gme_player PRIVATE ${SDL2_LIBRARIES} gme::gme)
    # Is not to be installed though

    if(GME_UNRAR)
      if(UNRAR_FOUND)
          message(STATUS "UnRAR library located, player demo will support the RAR file format")
          target_compile_definitions(gme_player PRIVATE RARDLL)
          if(RAR_HDR_UNRAR_H)
              target_compile_definitions(gme_player PRIVATE RAR_HDR_UNRAR_H)
          elseif(RAR_HDR_DLL_HPP)
              target_compile_definitions(gme_player PRIVATE RAR_HDR_DLL_HPP)
          endif()
          target_include_directories(gme_player PRIVATE ${UNRAR_INCLUDE_DIRS})
          target_link_libraries(gme_player PRIVATE ${UNRAR_LIBRARIES})
          # Is not to be installed though
          list(APPEND PC_LIBS -lunrar) # for libgme.pc
          if (NOT WIN32) # POSIX Threading for unRAR
              target_compile_options(gme_player PRIVATE -pthread)
          endif()
      else()
          message(STATUS "** UnRAR library not found, player demo will not support the RAR file format")
      endif()
    else()
      message(STATUS "RAR file format excluded")
    endif()

else()
    message(STATUS "** SDL library not found, disabling player demo build")
endif()

=== test/Makefile ===
# Add -I flags if you need them
CXXFLAGS := -O2
SRCS := basics.c Wave_Writer.cpp
SRCS_MEM := basics_mem.c Wave_Writer.cpp
INCLUDES := ../gme/
LIBRARIES := ../build/gme/
TEST_FILES := ../test.nsf  # Add more files here that you want in testsuite

all: demo demo_mem

# We will use LD_PRELOAD later to pick up the right libgme
demo: $(SRCS) Wave_Writer.h
	$(CXX) -I$(INCLUDES)  $(CXXFLAGS) -o $@ $(SRCS) -L$(LIBRARIES) -lgme

demo_mem: $(SRCS_MEM) Wave_Writer.h
	$(CXX) -I$(INCLUDES) $(CXXFLAGS) -o $@ $(SRCS_MEM) -L$(LIBRARIES) -lgme

test: demo demo_mem
	parallel --bar ./test.sh {} ::: $(TEST_FILES)

clean:
	rm -f demo
	rm -f demo_mem
	rm -f new/*.out cur/*.out
	rm -f newm/*.out curm/*.out
	rmdir new cur newm curm

=== debian/changelog ===
game-music-emu (0.6.4-1) unstable; urgency=medium

  * New upstream release
  * d/control: Bump Standards-Version from 4.6.2 to 4.7.2.
  * d/copyright: Update debian files copyright year to 2025.
  * d/rules: Update for upstream build changes.
  * d/libgme0.symbols: Update and add new symbols.
  * d/libgme-dev.install: Install libgme.a.
  * d/copyright: Fix Lintian warning, old-fsf-address-in-copyright-file.

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Wed, 29 Oct 2025 18:28:12 +0200

=== debian/control ===
Source: game-music-emu
Section: sound
Priority: optional
Maintainer: Ileana Dumitrescu <ileanadumitrescu95@gmail.com>
Build-Depends: debhelper (>= 13),
               debhelper-compat (= 13),
               cmake (>= 2.6),
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/libgme/game-music-emu
Vcs-Browser: https://salsa.debian.org/debian/game-music-emu
Vcs-Git: https://salsa.debian.org/debian/game-music-emu.git

Package: libgme0
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Playback library for video game music files - shared library
 game-music-emu is a collection of video game music file emulators that
 support the following formats and systems:
  * AY        ZX Spectrum/Amstrad CPC
  * GBS       Nintendo Game Boy
  * GYM       Sega Genesis/Mega Drive
  * HES       NEC TurboGrafx-16/PC Engine
  * KSS       MSX Home Computer/other Z80 systems (doesn't support FM sound)
  * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
  * SAP       Atari systems using POKEY sound chip
  * SPC       Super Nintendo/Super Famicom
  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive, BBC Micro
 .
 This package contains the shared libraries necessary to run programs
 using libgme.

Package: libgme-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgme0 (= ${binary:Version}),
         ${misc:Depends}
Description: Playback library for video game music files - development files
 game-music-emu is a collection of video game music file emulators that
 support the following formats and systems:
  * AY        ZX Spectrum/Amstrad CPC
  * GBS       Nintendo Game Boy
  * GYM       Sega Genesis/Mega Drive
  * HES       NEC TurboGrafx-16/PC Engine
  * KSS       MSX Home Computer/other Z80 systems (doesn't support FM sound)
  * NSF/NSFE  Nintendo NES/Famicom (with VRC 6, Namco 106, and FME-7 sound)
  * SAP       Atari systems using POKEY sound chip
  * SPC       Super Nintendo/Super Famicom
  * VGM/VGZ   Sega Master System/Mark III, Sega Genesis/Mega Drive, BBC Micro
 .
 This package contains the header files, static libraries
 and symbolic links that developers using libgme will need.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_UBSAN=OFF

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_auto_test:
# 	Skip flaky unittests

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%game-music-emu-$1.tar.gz%" \
  https://github.com/libgme/game-music-emu/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
